#include "WiFiEsp.h"

#include <SoftwareSerial.h> 
#define rxPin 3 
#define txPin 2 
SoftwareSerial esp01(txPin, rxPin); // SoftwareSerial NAME(TX, RX);

char ssid[] = "SK_WiFiGIGA40F7";            // your network SSID (name)
char pass[] = "1712037218";        // your network password
int status = WL_IDLE_STATUS;     // the Wifi radio's status

// https://api.openweathermap.org/data/2.5/weather?q=Seoul,KR&APPID=YOUR_API_KEY
const char* host = "api.openweathermap.org";
const String url = "/data/2.5/weather?q=Seoul,KR&APPID=YOUR_API_KEY";

// Initialize the Ethernet client object
WiFiEspClient client;

void setup() {
  Serial.begin(9600);  //시리얼모니터
  esp01.begin(9600);   //와이파이 시리얼
  WiFi.init(&esp01);   // initialize ESP module
  while ( status != WL_CONNECTED) {   // attempt to connect to WiFi network
    Serial.print("Attempting to connect to WPA SSID: ");
    Serial.println(ssid);
    status = WiFi.begin(ssid, pass);    // Connect to WPA/WPA2 network
  }
  Serial.println("You're connected to the network");
  printWifiStatus(); // wifi 상태표시 및 딜레이
  Serial.println();
  Serial.println("Starting connection to server...");
  if (client.connect(host, 80)) {
    Serial.println("Connected to server");
    client.print("GET " + url + " HTTP/1.1\r\n" +  
                 "Host: " + host + "\r\n" +  
                 "Connection: close\r\n\r\n");
  }
}

void loop() {
  while (client.available()) {
    char c = client.read();
    Serial.write(c);
  }
  if (!client.connected()) {
    Serial.println();
    Serial.println("Disconnecting from server...");
    client.stop();
    while (true); // do nothing forevermore
  }
}

void printWifiStatus() {
  Serial.print("SSID: ");   // print the SSID of the network you're attached to
  Serial.println(WiFi.SSID());
  IPAddress ip = WiFi.localIP();  // print your WiFi shield's IP address
  Serial.print("IP Address: ");
  Serial.println(ip);
  long rssi = WiFi.RSSI();  // print the received signal strength
  Serial.print("Signal strength (RSSI):");
  Serial.print(rssi);
  Serial.println(" dBm");
}
